<template>
  <Doughnut :data="preparedData" :options="options" />
</template>

<script>
import { Doughnut } from 'vue-chartjs';
import { Chart as ChartJS, ArcElement, Tooltip, Legend } from 'chart.js'
import ChartDataLabels from 'chartjs-plugin-datalabels';
ChartJS.register(ArcElement, Tooltip, Legend, ChartDataLabels)

export default {
  name: "DoughnutChart",
  components: { Doughnut },
  props: {
    // eslint-disable-next-line vue/require-default-prop
    chartData: {
      type: [Array, Object],
      required: true
    },
    chartLabels: {
      type: Array,
      required: true
    },
    chartBackgroundColors: {
      type: Array,
      required: false,
      default () {
        return [
          'rgb(41, 114, 170)',
          'rgb(242, 242, 242)',
          'rgb(159, 242, 223)'
        ]
      }
    },
    title: {
      type: String,
      default: '[No title]',
      required: false
    }
  },
  data() {
    return {
      preparedData: {
        labels: this.chartLabels,
        datasets: [
          {
            label: this.title,
            data: this.chartData,
            backgroundColor: this.chartBackgroundColors
          }
        ]
      },
      options: {
        title: {
          display: false,
          text: this.title
        },
        scales: {},
        // responsive: true,
        // maintainAspectRatio: false,
        cutout: 60,
        plugins: {
          legend: {
            display: false
          },
          tooltip: {
            // Toolbar an/aus
            enabled: true
          },
          datalabels: {
            display: true,
            color: ['white', 'black'],
            formatter: value => value === 0? '' : `${value}%`
          }
        }
      }
    }
  }
};
</script>
